### v0.29.3
- Fixed wrong save slot being deleted when quicksaving
- Fixed a crash in Hexen
- Fixed building dsda-doom.wad in big-endian hosts (FtZPetruska)
- Improved statusbar color background algorithm (andrikpowell)

### v0.29.2
- Fixed crash with autosaves

### v0.29.1
- Clickable demo progress bar
  - Click to skip to that point
  - To make skipping faster, the closest keyframe is used as the starting point
  - There are new `playback keyframes` spread around the demo
  - Blue lines are `playback keyframes`, green lines are `rewind keyframes`
  - The mouse becomes visible while moving during demos
  - New `Playback Mouse Controls` option to toggle this behaviour
- Added page just for quicksaves
  - You can now have multiple quicksaves at a time
- Added Keypad Enter to keys that pop-up the menu
- Added customisable View and Weapon Bob percentages (andrikpowell)
  - Uses a new config name, so resets the setting for everyone
- Added colored statusbar background option (andrikpowell)
- Added `Translucent Sprites option (andrikpowell)
  - `Off`, `Default`, `w/ Vanilla`
- Added `Translucent Ghosts` option (andrikpowell)
- Added Hexen skill strings for cheats (andrikpowell)
- Added `extra_level_brightness` config (mincardona)
  - Config only for now
- Added `dsda_demo_end_quit` (feos)
- Added new thing automap appearance `hitboxes` (feos)
- Added `XDG_DATA_HOME` and `XDG_DATA_DIRS` to search paths (DankRank)
- Added Automap marks to Raven (andrikpowell)
- Removed dynamic Help screen
  - In favor of simply showing the HELP graphic
- Allow customisation of the F1 key
- Allow binding scroll wheel to weapons
- Allow setting `Gray %` even if `Colored Numbers` is off (andrikpowell)
- Allow Episode 4 in cl2 if there is a E4M1 lump (andrikpowell)
- Allow choosing `previous weapon` in vanilla with the chainsaw selected (andrikpowell)
- Allow pausing during skipping
- Mark death exits on the Automap
- Enable cross-compilation in one build (FtZPetruska)
- Various CMake improvements (FtZPetruska)
- Don't hide stbar numbers on menu (andrikpowell)
- Force menu off during Heretic E2 end screen (andrikpowell)
- Fixed `The D_DDTBLU disease` midi issue
- Fixed some `M_DOOM` images being distorted in Software
- Fixed `-chain_episodes` not working with UMAPINFO
- Fixed menu not opening after episode end in Heretic (andrikpowell)
- Fixed level table not marking value as max if above max (andrikpowell)
- Fixed a crash by skipping SMMU swirling flats (andrikpowell)
- Fixed linedef action 272 not flipping the sky in OpenGL
- Fixed Hexen weapon pieces HUD position (andrikpowell)
- Fixed some issues with the dark fade overlay (andrikpowell)
- Fixed big_ widgets colors not following `Colored Numbers` setting (andrikpowell)
- Fixed some crosshairs not being fullbright (thekovic)
- Fixed Hexen keys being visually removed when exiting a map in the same hub (andrikpowell)
- Fixed a hang when quiting while skipping on macOS
- Fixed widescreen assets that rely on offsets (andrikpowell)
- Drop DUMB player in favor of libopenmpt (qookei)

### v0.29.0

#### Menu Rework
- Reorganized all menus
- Added tabs
  - For Keybindings, the tabs use a carrousel
- Added scrollbar for vertically scrolling pages
- Added new menus "Display" "Demos" "Compatibility"
  - Officially drops support for the boom menu graphics
- Removed the menus "Sound Volume" "Status Bar / HUD"
- Disabled strict options during strict mode
- Enforce maximum line height
- Uses the hud font instead of the exhud font on Raven
- New graphics for < > & on Raven (andrikpowell)

#### Demos
- Strict mode is now On by default when recording demos
  - The menu option only disables it temporarly
- Increased demo features size to 128
- Don't allow saving the game on strict mode

#### Lumps
- Added GAMEINFO support (andrikpowell)
  - Only supports the "iwad" field
- Added E#M# lump detection (andrikpowell)
  - Loads Doom1 instead of Doom2 if detected

#### Miscellaneous
- Added config option for toggling aspect ratio correction
- Added config option for starting the window in a different display
- Added linear sky scrolling option for Software renderer (andrikpowell)
- Added button states to Save games (andrikpowell)
- Added smooth chainsaw bobbing (andrikpowell)
  - Only when Uncapped FPS is On
- Remove SysEx support from FluidSynth midi player (ceski)
- Improved looping for older midi hardware devices (ceski)
- Improved support for TC games (andrikpowell)
- Improved automap (andrikpowell)
  - Clear Last Mark instead of Clear Marks
  - New colors for "Alt Secret Exit line" and "Tag Finder line"
- Various cheat improvements (andrikpowell)
  - Checks if a map exists before changing music with IDMUS
  - Added status for TNTCOMP and IDCLEV
  - New cheat SKILL
  - Disabled TNTCOMP for Raven
- Rename "Use Red Numbers" to "Colored Numbers" (andrikpowell)
  - Resets the setting for all players
- Separate Player Trail Mode option (andrikpowell)
- Show E2M9 on intermission screen if it has been completed (andrikpowell)
- Show E2M7 (instead of E2M5) screen on intermission for E2M8 (andrikpowell)

#### Bug Fixes
- Fixed sdl_video_window_pos not being able to move fullscreen window to another display
- Fixed shaded overlay in Hexen caused by FOGMAP (andrikpowell)
- Fixed walls beind too bright in OpenGL (jackrjli)
- Reintroduce complevel check for Ultimate Doom Episode 4 (Spectere)
- Fixed desync with chainsaw weapon switch on Vanilla (andrikpowell)
- Fixed weapon being visible at the start of the level (andrikpowell)
- Fixed statusbar not refreshing when changing viewsize on Software (andrikpowell)
- Fixed gnrock being drawn on top of hud during the wipe screen (andrikpowell)
- Fixed an animation issue with Hexen melee weapons (andrikpowell)
- Fixed an animation issue with A_Raise and A_Lower states on custom weapons (andrikpowell)
- Fixed IDMUS not working correctly on Doom1 (andrikpowell)
- Fixed face not reflecting the current health when loading a new level or save (andrikpowell)
- Fixed -save not working when the folder has a backslash on Linux
- Fixed intermission animation timers not being reset (andrikpowell)
- Fixed text screen being skipped in E#M8 when using UMAPINFO (andrikpowell)
- Fixed lower skill stats being kept even if a higher skill run is completed (thecnoNSMB)
- Fixed sounds from SNDINFO overriding DEHACKED sounds (clearyf)
- Fixed wrong sky drawing if freelook is on, but not allowed
- Fixed wrong OpenGL tall skies vertical position (bangstk)
- Fixed animated skies not being animated when defined via UMAPINFO
- Fixed potential hang after restoring keyframe (PeterN)
- Fixed poor performance from retrying sighting a player over and over again (jackrjli)
